Index: /palm/trunk/SOURCE/local_stop.f90
===================================================================
--- /palm/trunk/SOURCE/local_stop.f90	(revision 666)
+++ /palm/trunk/SOURCE/local_stop.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Exchange of terminate_coupled between ocean and atmosphere via PE0
 !
 ! Former revisions:
@@ -63,8 +63,11 @@
              IF ( terminate_coupled == 0 )  THEN
                 terminate_coupled = 1
-                CALL MPI_SENDRECV( &
-                     terminate_coupled,        1, MPI_INTEGER, target_id,  0, &
-                     terminate_coupled_remote, 1, MPI_INTEGER, target_id,  0, &
-                     comm_inter, status, ierr )
+                IF ( myid == 0 ) THEN
+                   CALL MPI_SENDRECV( &
+                        terminate_coupled,        1, MPI_INTEGER, target_id,  0, &
+                        terminate_coupled_remote, 1, MPI_INTEGER, target_id,  0, &
+                        comm_inter, status, ierr )
+                ENDIF
+                CALL MPI_BCAST( terminate_coupled_remote, 1, MPI_REAL, 0, comm2d, ierr)
              ENDIF
              CALL MPI_FINALIZE( ierr )
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 666)
+++ /palm/trunk/SOURCE/modules.f90	(revision 667)
@@ -5,5 +5,36 @@
 ! Current revisions:
 ! -----------------
+!
+! Removed u_nzb_p1_for_vfc and v_nzb_p1_for_vfc
+!
+! For coupling with different resolution in ocean and atmophere:
+! +nx_a, +nx_o, ny_a, +ny_o, ngp_a, ngp_o, +total_2d_o, +total_2d_a,
+! +coupling_topology 
+!
+!
+! Buffer arrays for the left sided advective fluxes added in arrays_3d.
+! +flux_s_u, +flux_s_v, +flux_s_w, +diss_s_u, +diss_s_v, +diss_s_w,
+! +flux_s_pt, +diss_s_pt, +flux_s_e, +diss_s_e, +flux_s_q, +diss_s_q,
+! +flux_s_sa, +diss_s_sa
+! 3d arrays for dissipation control added. (only necessary for vector arch.)
+! +var_x, +var_y, +var_z, +gamma_x, +gamma_y, +gamma_z
+! Default of momentum_advec and scalar_advec changed to 'ws-scheme' .
+! +exchange_mg added in control_parameters to steer the data exchange.
+! Parameters +nbgp, +nxlg, +nxrg, +nysg, +nyng added in indices.
+! flag array +boundary_flags added in indices to steer the degradation of order 
+! of the advective fluxes when non-cyclic boundaries are used.
+! MPI-datatypes +type_y, +type_y_int and +type_yz for data_exchange added in 
+! pegrid.
+! +sums_wsus_ws_l, +sums_wsvs_ws_l, +sums_us2_ws_l, +sums_vs2_ws_l, 
+! +sums_ws2_ws_l, +sums_wspts_ws_l, +sums_wssas_ws_l, +sums_wsqs_ws_l 
+! and +weight_substep added in statistics to steer the statistical evaluation 
+! of turbulent fluxes in the advection routines.
+! LOGICALS +ws_scheme_sca and +ws_scheme_mom added to get a better performance
+! in prognostic_equations.
+! LOGICAL +dissipation_control control added to steer numerical dissipation
+! in ws-scheme.
 ! 
+!
+! Changed length of string run_description_header
 !
 ! Former revisions:
@@ -51,7 +82,16 @@
 ! ws_vertical_gradient_level_ind, w_subs
 !
-! 410 2009-12-04 17:05:40Z letzel
-! masked data output: + dt_domask, mask_01~20_x|y|z, mask_01~20_x|y|z_loop, 
+! Branch revisions:
+! -----------------
+! Masked data output: + dt_domask, mask_01~20_x|y|z, mask_01~20_x|y|z_loop, 
 ! mask_scale|_x|y|z, masks, skip_time_domask
+!
+! control_parameters: scalar and momentum advection set to 'ws-scheme' as
+! default scheme
+! indices: nbgp=3 set as default value
+!
+! Former revisions:
+! -----------------
+! $Id$
 !
 ! 388 2009-09-23 09:40:33Z raasch
@@ -190,11 +230,17 @@
 
     REAL, DIMENSION(:), ALLOCATABLE ::                                         &
-          ddzu, dd2zu, dzu, ddzw, dzw, hyp, inflow_damping_factor, km_damp_x,  &
-          km_damp_y, lad, l_grid, pt_init, q_init, rdf, sa_init, ug, u_init,   &
-          u_nzb_p1_for_vfc, vg, v_init, v_nzb_p1_for_vfc, w_subs, zu, zw
+          ddzu, ddzu_pres, dd2zu, dzu, ddzw, dzw, hyp, inflow_damping_factor,  &
+          km_damp_x, km_damp_y, lad, l_grid, pt_init, q_init, rdf, sa_init,    &
+          ug, u_init, u_nzb_p1_for_vfc, vg, v_init, v_nzb_p1_for_vfc, w_subs,  &
+          zu, zw, flux_s_u, flux_s_v, flux_s_w, diss_s_u, diss_s_v, diss_s_w,  &
+          flux_s_pt, diss_s_pt, flux_s_e, diss_s_e, flux_s_q, diss_s_q,        &
+          flux_s_sa, diss_s_sa
 
     REAL, DIMENSION(:,:), ALLOCATABLE ::                                       &
           c_u, c_v, c_w, dzu_mg, dzw_mg, f1_mg, f2_mg, f3_mg,                  &
-          mean_inflow_profiles, pt_slope_ref, qs, qswst_remote, ts, us, z0
+          mean_inflow_profiles, pt_slope_ref, qs, qswst_remote, ts, us, z0,    &
+          flux_l_u, flux_l_v, flux_l_w, diss_l_u, diss_l_v, diss_l_w,          &
+          flux_l_pt, diss_l_pt, flux_l_e, diss_l_e, flux_l_q, diss_l_q,        &
+          flux_l_sa, diss_l_sa, total_2d_o, total_2d_a
 
     REAL, DIMENSION(:,:), ALLOCATABLE, TARGET ::                               &
@@ -227,4 +273,7 @@
 
     REAL, DIMENSION(:,:,:,:), ALLOCATABLE ::  rif_wall
+
+    REAL, DIMENSION(:,:,:), ALLOCATABLE :: var_x, var_y, var_z, gamma_x,        &
+                                           gamma_y, gamma_z
 
     SAVE
@@ -290,4 +339,6 @@
 
     REAL    ::  pi = 3.141592654
+    REAL    ::  adv_sca_5, adv_sca_3, adv_mom_5, adv_mom_3
+    
 
     SAVE
@@ -336,7 +387,7 @@
     CHARACTER (LEN=16)   ::  conserve_volume_flow_mode = 'default', &
                              loop_optimization = 'default', &
-                             momentum_advec = 'pw-scheme', &
+                             momentum_advec = 'ws-scheme', &
                              psolver = 'poisfft', &
-                             scalar_advec = 'pw-scheme'
+                             scalar_advec = 'ws-scheme'
     CHARACTER (LEN=20)   ::  bc_e_b = 'neumann', bc_lr = 'cyclic', &
                              bc_ns = 'cyclic', bc_p_b = 'neumann', &
@@ -359,5 +410,6 @@
     CHARACTER (LEN=64)   ::  host = ' '
     CHARACTER (LEN=80)   ::  log_message, run_identifier
-    CHARACTER (LEN=100)  ::  initializing_actions = ' ', run_description_header
+    CHARACTER (LEN=100)  ::  initializing_actions = ' ' 
+    CHARACTER (LEN=110)  ::  run_description_header
     CHARACTER (LEN=1000) ::  message_string = ' '
 
@@ -378,4 +430,5 @@
     INTEGER ::  abort_mode = 1, average_count_pr = 0, average_count_sp = 0, &
                 average_count_3d = 0, current_timestep_number = 0, &
+                coupling_topology = 0, &
                 dist_range = 0, disturbance_level_ind_b, &
                 disturbance_level_ind_t, doav_n = 0, dopr_n = 0, &
@@ -432,9 +485,11 @@
                 constant_waterflux = .TRUE., create_disturbances = .TRUE., &
                 cut_spline_overshoot = .TRUE., &
-                data_output_2d_on_each_pe = .TRUE., do2d_at_begin = .FALSE., &
+                data_output_2d_on_each_pe = .TRUE., & 
+                dissipation_control = .FALSE., do2d_at_begin = .FALSE., &
                 do3d_at_begin = .FALSE., do3d_compress = .FALSE., &
                 do_sum = .FALSE., dp_external = .FALSE., dp_smooth = .FALSE., &
                 dt_changed = .FALSE., dt_fixed = .FALSE., &
                 disturbance_created = .FALSE., &
+                exchange_mg = .FALSE., &
                 first_call_advec_particles = .TRUE., &
                 force_print_header = .FALSE., galilei_transformation = .FALSE.,&
@@ -457,5 +512,6 @@
                 use_surface_fluxes = .FALSE., use_top_fluxes = .FALSE., &
                 use_ug_for_galilei_tr = .TRUE., use_upstream_for_tke = .FALSE.,&
-                wall_adjustment = .TRUE.
+                wall_adjustment = .TRUE., ws_scheme_sca = .FALSE.,             &
+                ws_scheme_mom = .FALSE.
 
     LOGICAL ::  data_output_xy(0:1) = .FALSE., data_output_xz(0:1) = .FALSE., &
@@ -761,7 +817,9 @@
 !------------------------------------------------------------------------------!
 
-    INTEGER ::  ngp_sums, nnx, nx = 0, nxa, nxl, nxlu, nxr, nxra, nx_on_file,  &
-                nny, ny = 0, nya, nyn, nyna, nys, nysv, ny_on_file, nnz,       &
-                nz = 0, nza, nzb, nzb_diff, nzt, nzta, nzt_diff
+    INTEGER ::  nbgp = 3, ngp_sums, nnx, nx = 0, nx_a, nx_o, nxa, nxl, nxlg,   &
+                nxlu, nxr, nxra, nxrg, nx_on_file, nny, ny = 0, ny_a, ny_o,    &
+                nya, nyn, nyna, nyng, nys, nysg, nysv, ny_on_file, nnz, nz = 0,&
+                nza, nzb, nzb_diff, nzt, nzta, nzt_diff
+
 
     INTEGER( KIND = SELECTED_INT_KIND(18) ), DIMENSION(:), ALLOCATABLE ::      &
@@ -771,5 +829,6 @@
                 ngp_2dh, nnx_pe, nny_pe, nxl_mg, nxr_mg, nyn_mg, nys_mg, nzt_mg
 
-    INTEGER, DIMENSION(:,:), ALLOCATABLE ::                                    &
+
+    INTEGER, DIMENSION(:,:), ALLOCATABLE :: boundary_flags,                    &
                 ngp_2dh_outer, ngp_2dh_s_inner, mg_loc_ind, nzb_diff_s_inner,  &
                 nzb_diff_s_outer, nzb_diff_u, nzb_diff_v, nzb_inner, nzb_outer,&
@@ -1157,12 +1216,13 @@
 
     INTEGER ::  comm1dx, comm1dy, comm2d, comm_inter, comm_palm, ierr, myidx,  &
-                myidy, ndim = 2, ngp_xy, ngp_y, pleft, pnorth, pright, psouth, &
+                myidy, ndim = 2, ngp_a, ngp_o, ngp_xy, ngp_y,                  &
+                pleft, pnorth, pright, psouth,                                 &
                 sendrecvcount_xy, sendrecvcount_yz, sendrecvcount_zx,          &
                 sendrecvcount_zyd, sendrecvcount_yxd,                          &
-                type_x, type_x_int, type_xy
+                type_x, type_x_int, type_xy, type_y, type_y_int
 
     INTEGER ::  ibuf(12), pcoord(2), pdims(2), status(MPI_STATUS_SIZE)
 
-    INTEGER, DIMENSION(:), ALLOCATABLE ::  ngp_yz, type_xz
+    INTEGER, DIMENSION(:), ALLOCATABLE ::  ngp_yz, type_xz, type_yz
 
     LOGICAL ::  collective_wait = .FALSE., reorder = .TRUE.
@@ -1325,6 +1385,12 @@
     LOGICAL ::  flow_statistics_called = .FALSE.
     REAL ::     u_max, v_max, w_max
-    REAL, DIMENSION(:), ALLOCATABLE       ::  sums_divnew_l, sums_divold_l
-    REAL, DIMENSION(:,:), ALLOCATABLE     ::  sums, sums_wsts_bc_l, ts_value
+    REAL, DIMENSION(:), ALLOCATABLE       ::  sums_divnew_l, sums_divold_l, &
+                                              weight_substep
+    REAL, DIMENSION(:,:), ALLOCATABLE     ::  sums, sums_wsts_bc_l,        &
+                                              sums_wsus_ws_l, sums_wsvs_ws_l,&
+                                              sums_us2_ws_l, sums_vs2_ws_l, &
+                                              sums_ws2_ws_l,                 &
+                                              sums_wspts_ws_l, sums_wssas_ws_l, &
+                                              sums_wsqs_ws_l, ts_value
     REAL, DIMENSION(:,:,:), ALLOCATABLE   ::  hom_sum, rmask, spectrum_x, &
                                               spectrum_y, sums_l, sums_l_l, &
Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 666)
+++ /palm/trunk/SOURCE/parin.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Steering parameter dissipation_control added in inipar. (commented out)
 !
 ! Former revisions:
@@ -124,9 +124,9 @@
              collective_wait, conserve_volume_flow, conserve_volume_flow_mode, &
              coupling_start_time, cthf, cut_spline_overshoot, &
-             cycle_mg, damp_level_1d, dissipation_1d, dp_external, dp_level_b, &
-             dp_smooth, dpdxy, drag_coefficient, dt, dt_pr_1d, &
-             dt_run_control_1d, dx, dy, dz, dz_max, dz_stretch_factor, & 
-             dz_stretch_level, e_init, e_min, end_time_1d, fft_method, &
-             galilei_transformation, grid_matching, humidity, &
+             cycle_mg, damp_level_1d, dissipation_1d, & !dissipation_control, &
+             dp_external, dp_level_b, dp_smooth, dpdxy, drag_coefficient, &
+             dt, dt_pr_1d, dt_run_control_1d, dx, dy, dz, dz_max, & 
+             dz_stretch_factor, dz_stretch_level, e_init, e_min, end_time_1d, &
+             fft_method, galilei_transformation, grid_matching, humidity, &
              inflow_damping_height, inflow_damping_width, &
              inflow_disturbance_begin, inflow_disturbance_end, &
@@ -190,5 +190,5 @@
     NAMELIST /envpar/  host, local_dvrserver_running, maximum_cpu_time_allowed,  &
                        revision, return_addres, return_username, run_identifier, &
-                       tasks_per_node, write_binary
+                       tasks_per_node, write_binary                     
 
 !
@@ -278,4 +278,5 @@
                  hom(0:nz+1,2,pr_palm+max_pr_user,0:statistic_regions),        &
                  hom_sum(0:nz+1,pr_palm+max_pr_user,0:statistic_regions) )
+
        hom = 0.0
 
Index: /palm/trunk/SOURCE/poisfft.f90
===================================================================
--- /palm/trunk/SOURCE/poisfft.f90	(revision 666)
+++ /palm/trunk/SOURCE/poisfft.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! ddzu replaced by ddzu_pres due to changes in zu(0).
 !
 ! Former revisions:
@@ -287,6 +287,6 @@
        DO  k = 0, nz-1
           DO  i = nxl_z, nxr_z
-             tri(2,i,k) = ddzu(k+1) * ddzw(k+1)
-             tri(3,i,k) = ddzu(k+2) * ddzw(k+1)
+             tri(2,i,k) = ddzu_pres(k+1) * ddzw(k+1)
+             tri(3,i,k) = ddzu_pres(k+2) * ddzw(k+1)
           ENDDO
        ENDDO
@@ -367,6 +367,6 @@
              ENDIF
              DO  k = 0,nz-1
-                a = -1.0 * ddzu(k+2) * ddzw(k+1)
-                c = -1.0 * ddzu(k+1) * ddzw(k+1)
+                a = -1.0 * ddzu_pres(k+2) * ddzw(k+1)
+                c = -1.0 * ddzu_pres(k+1) * ddzw(k+1)
                 tri(1,i,k) = a + c - ll(i)
              ENDDO
@@ -379,6 +379,6 @@
                            ( dy * dy )
              DO  k = 0, nz-1
-                a = -1.0 * ddzu(k+2) * ddzw(k+1)
-                c = -1.0 * ddzu(k+1) * ddzw(k+1)
+                a = -1.0 * ddzu_pres(k+2) * ddzw(k+1)
+                c = -1.0 * ddzu_pres(k+1) * ddzw(k+1)
                 tri(1,i,k) = a + c - ll(i)
                 IF ( i >= 1 .and. i < nnxh )  THEN
@@ -1363,6 +1363,6 @@
        DO  k = 0, nz-1
           DO  i = 0,nx
-             tri(2,i,k) = ddzu(k+1) * ddzw(k+1)
-             tri(3,i,k) = ddzu(k+2) * ddzw(k+1)
+             tri(2,i,k) = ddzu_pres(k+1) * ddzw(k+1)
+             tri(3,i,k) = ddzu_pres(k+2) * ddzw(k+1)
           ENDDO
        ENDDO
@@ -1439,6 +1439,6 @@
           DO  k = 0, nz-1
              DO  i = 0, nx
-                a = -1.0 * ddzu(k+2) * ddzw(k+1)
-                c = -1.0 * ddzu(k+1) * ddzw(k+1)
+                a = -1.0 * ddzu_pres(k+2) * ddzw(k+1)
+                c = -1.0 * ddzu_pres(k+1) * ddzw(k+1)
                 tri(1,i,k) = a + c - l(i)
              ENDDO
Index: /palm/trunk/SOURCE/poisfft_hybrid.f90
===================================================================
--- /palm/trunk/SOURCE/poisfft_hybrid.f90	(revision 666)
+++ /palm/trunk/SOURCE/poisfft_hybrid.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions: 
 ! ----------------- 
-! 
+! ddzu replaced by ddzu_pres due to changes in zu(0).
 !
 ! Former revisions: 
@@ -848,6 +848,6 @@
        DO  k = 0, nz-1
           DO  i = 0,nx
-             tri(2,i,k) = ddzu(k+1) * ddzw(k+1)
-             tri(3,i,k) = ddzu(k+2) * ddzw(k+1)
+             tri(2,i,k) = ddzu_pres(k+1) * ddzw(k+1)
+             tri(3,i,k) = ddzu_pres(k+2) * ddzw(k+1)
           ENDDO
        ENDDO
@@ -908,6 +908,6 @@
           DO  k = 0,nz-1
              DO  i = 0, nx
-                a = -1.0 * ddzu(k+2) * ddzw(k+1)
-                c = -1.0 * ddzu(k+1) * ddzw(k+1)
+                a = -1.0 * ddzu_pres(k+2) * ddzw(k+1)
+                c = -1.0 * ddzu_pres(k+1) * ddzw(k+1)
                 tri(1,i,k) = a + c - l(i)
              ENDDO
Index: /palm/trunk/SOURCE/poismg.f90
===================================================================
--- /palm/trunk/SOURCE/poismg.f90	(revision 666)
+++ /palm/trunk/SOURCE/poismg.f90	(revision 667)
@@ -8,5 +8,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Calls of exchange_horiz are modified.
 !
 ! Former revisions:
@@ -70,5 +70,4 @@
     CALL cpu_log( log_point_s(29), 'poismg', 'start' )
 
-
 !
 !-- Initialize arrays and variables used in this subroutine
@@ -78,5 +77,5 @@
 !
 !-- Some boundaries have to be added to divergence array
-    CALL exchange_horiz( d )
+    CALL exchange_horiz( d, 1)
     d(nzb,:,:) = d(nzb+1,:,:)
 
@@ -220,5 +219,5 @@
 !
 !-- Horizontal boundary conditions
-    CALL exchange_horiz( r )
+    CALL exchange_horiz( r, 1)
 
     IF ( bc_lr /= 'cyclic' )  THEN
@@ -393,5 +392,5 @@
 !
 !-- Horizontal boundary conditions
-    CALL exchange_horiz( f_mg )
+    CALL exchange_horiz( f_mg, 1)
 
     IF ( bc_lr /= 'cyclic' )  THEN
@@ -491,5 +490,5 @@
 !
 !-- Horizontal boundary conditions
-    CALL exchange_horiz( temp )
+    CALL exchange_horiz( temp, 1)
 
     IF ( bc_lr /= 'cyclic' )  THEN
@@ -861,5 +860,5 @@
 !
 !--       Horizontal boundary conditions
-          CALL exchange_horiz( p_mg )
+          CALL exchange_horiz( p_mg, 1 )
 
           IF ( bc_lr /= 'cyclic' )  THEN
@@ -936,5 +935,5 @@
 !
 !-- One more time horizontal boundary conditions
-    CALL exchange_horiz( p_mg )
+    CALL exchange_horiz( p_mg, 1)
 
  END SUBROUTINE redblack
Index: /palm/trunk/SOURCE/prandtl_fluxes.f90
===================================================================
--- /palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 666)
+++ /palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 667)
@@ -4,5 +4,9 @@
 ! Current revisions:
 ! -----------------
-! 
+!
+! Changed surface boundary conditions for u and v from mirror bc to dirichelt bc,
+! therefore u(uzb,:,:) and v(nzb,:,:) is now representative for the height z0
+!
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
 !
 ! Former revisions:
@@ -53,5 +57,5 @@
     REAL    ::  a, b, e_q, rifm, uv_total, z_p
 
-!
+! 
 !-- Compute theta*
     IF ( constant_heatflux )  THEN
@@ -60,6 +64,6 @@
 !--    for u* use the value from the previous time step
        !$OMP PARALLEL DO
-       DO  i = nxl-1, nxr+1
-          DO  j = nys-1, nyn+1
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
              ts(j,i) = -shf(j,i) / ( us(j,i) + 1E-30 )
 !
@@ -76,6 +80,6 @@
 !--    (the Richardson number is still the one from the previous time step)
        !$OMP PARALLEL DO PRIVATE( a, b, k, z_p )
-       DO  i = nxl-1, nxr+1
-          DO  j = nys-1, nyn+1
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
 
              k   = nzb_s_inner(j,i)
@@ -108,6 +112,6 @@
     IF ( .NOT. humidity )  THEN
        !$OMP PARALLEL DO PRIVATE( k, z_p )
-       DO  i = nxl-1, nxr+1
-          DO  j = nys-1, nyn+1
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
              k   = nzb_s_inner(j,i)
              z_p = zu(k+1) - zw(k)
@@ -126,6 +130,6 @@
     ELSE
        !$OMP PARALLEL DO PRIVATE( k, z_p )
-       DO  i = nxl-1, nxr+1
-          DO  j = nys-1, nyn+1
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
              k   = nzb_s_inner(j,i)
              z_p = zu(k+1) - zw(k)
@@ -155,8 +159,11 @@
 
 !
-!--       Compute the absolute value of the horizontal velocity
-          uv_total = SQRT( ( 0.5 * ( u(k+1,j,i) + u(k+1,j,i+1) ) )**2 + &
-                           ( 0.5 * ( v(k+1,j,i) + v(k+1,j+1,i) ) )**2   &
-                         )
+!--       Compute the absolute value of the horizontal velocity 
+!--       (relative to the surface)
+          uv_total = SQRT( ( 0.5 * ( u(k+1,j,i) + u(k+1,j,i+1)        &
+                                   - u(k,j,i)   - u(k,j,i+1) ) )**2 + &
+                           ( 0.5 * ( v(k+1,j,i) + v(k+1,j+1,i)        &
+                                   - v(k,j,i)   - v(k,j+1,i) ) )**2 )    
+
 
           IF ( rif(j,i) >= 0.0 )  THEN
@@ -203,5 +210,5 @@
 !
 !--          Stable stratification
-             usws(j,i) = kappa * u(k+1,j,i) / (                           &
+             usws(j,i) = kappa * ( u(k+1,j,i) - u(k,j,i) )/ (              &
                                      LOG( z_p / z0(j,i) ) +               &
                                      5.0 * rifm * ( z_p - z0(j,i) ) / z_p &
@@ -213,5 +220,5 @@
              b = SQRT( SQRT( 1.0 - 16.0 * rifm / z_p * z0(j,i) ) )
 
-             usws(j,i) = kappa * u(k+1,j,i) / (                           &
+             usws(j,i) = kappa * ( u(k+1,j,i) - u(k,j,i) ) / (            &
                          LOG( z_p / z0(j,i) ) -                           &
                          LOG( (1.0 + a )**2 * ( 1.0 + a**2 ) / (          &
@@ -240,5 +247,5 @@
 !
 !--          Stable stratification
-             vsws(j,i) = kappa * v(k+1,j,i) / (                           &
+             vsws(j,i) = kappa * ( v(k+1,j,i) -  v(k,j,i) ) / (           &
                                      LOG( z_p / z0(j,i) ) +               &
                                      5.0 * rifm * ( z_p - z0(j,i) ) / z_p &
@@ -250,5 +257,5 @@
              b = SQRT( SQRT( 1.0 - 16.0 * rifm / z_p * z0(j,i) ) )
 
-             vsws(j,i) = kappa * v(k+1,j,i) / (                           &
+             vsws(j,i) = kappa * ( v(k+1,j,i) - v(k,j,i) ) / (            &
                          LOG( z_p / z0(j,i) ) -                           &
                          LOG( (1.0 + a )**2 * ( 1.0 + a**2 ) / (          &
@@ -268,6 +275,6 @@
 !--       For a given water flux in the Prandtl layer:
           !$OMP PARALLEL DO
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 qs(j,i) = -qsws(j,i) / ( us(j,i) + 1E-30 )
              ENDDO
@@ -276,6 +283,6 @@
        ELSE          
           !$OMP PARALLEL DO PRIVATE( a, b, k, z_p )
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
 
                 k   = nzb_s_inner(j,i)
@@ -325,6 +332,6 @@
     IF ( .NOT. constant_heatflux )  THEN
        !$OMP PARALLEL DO
-       DO  i = nxl-1, nxr+1
-          DO  j = nys-1, nyn+1
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
              shf(j,i) = -ts(j,i) * us(j,i)
           ENDDO
@@ -336,6 +343,6 @@
     IF ( .NOT. constant_waterflux .AND. ( humidity .OR. passive_scalar ) ) THEN
        !$OMP PARALLEL DO
-       DO  i = nxl-1, nxr+1
-          DO  j = nys-1, nyn+1
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
              qsws(j,i) = -qs(j,i) * us(j,i)
           ENDDO
@@ -347,6 +354,6 @@
     IF ( ibc_e_b == 2 )  THEN
        !$OMP PARALLEL DO
-       DO  i = nxl-1, nxr+1
-          DO  j = nys-1, nyn+1
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
              e(nzb_s_inner(j,i)+1,j,i) = ( us(j,i) / 0.1 )**2
 !
